<?php

interface iBatchOperation {
  public function getTotal();
  public function process($current, $total);
}

class Database {
  function __construct() {
    $dbhost = variable_get('dadaimc2drupal_dbhost', NULL);
    $dbuser = variable_get('dadaimc2drupal_dbuser', NULL);
    $dbpass = variable_get('dadaimc2drupal_dbpass', NULL);
    $dbname = variable_get('dadaimc2drupal_dbname', NULL);
    $this->dbConnect($dbhost, $dbuser, $dbpass, $dbname);  
  }
  
  /**
   * Stablish a connection to the database.
   */
  function dbConnect($dbhost, $dbuser, $dbpass, $dbname) {
    $link = @mysql_connect($dbhost, $dbuser, $dbpass, TRUE, 2);
    if (!$link) {
      drupal_set_message(t('Unable to connect to database at «%host» with user «%user» and password «%pass».', array('%host' => $dbhost, '%user' => $dbuser, '%pass' => $dbpass)), 'error');
    }
    elseif (!mysql_select_db($dbname)) {
        drupal_set_message(t('Unable to select database :db.', array(':db' => $dbname)), 'error');
        $link = FALSE;
    }
    if (!$link) {
      form_set_error('', t("Unable to stablish a connection to DadaIMC database. Review the settings in the <a href='@url'>database configuration page</a>.", array('@url'=>url('admin/settings/dadaimc2drupal'))));
    }
    mysql_query('SET NAMES "utf8"', $link);

    $this->link = $link;
  }

  /**
   * Executes a query on the database.
   *
   * The query is in drupal format, that is, you can use {} around
   * the table names.
   */
  function dbQuery($query) {
    $args = func_get_args();
    array_shift($args);
    // 'All arguments in one array' syntax?
    if (isset($args[0]) and is_array($args[0])) {
      $args = $args[0];
    }
    _db_query_callback($args, TRUE);
    $query = preg_replace_callback(DB_QUERY_REGEXP, '_db_query_callback', $query);
    $query = strtr($query, array('{' => $this->dbPrefix, '}' => ''));
    $result = mysql_query($query, $this->link);

    if (!mysql_errno($this->link)) {
      return $result;
    }
    else {
      // Indicate to drupal_error_handler that this is a database error.
      ${DB_ERROR} = TRUE;
      trigger_error(check_plain(mysql_error($this->link) ."\nThe query was: ". $query), E_USER_WARNING);
      return FALSE;
    }
  }
}

class BaseBatchOperation extends Database {
  static function execute(&$context, $step = 20) {
     $class = get_called_class();
     $operation = new $class($context, $step);
  }

  function __construct(&$context, $step) {
    // Initialize database connection.
    parent::__construct();

    $this->filesPath = file_directory_path() . '/usermedia/';

    // Initialize batch context.
    $this->context = &$context;
    $this->step = $step;
    // If it is the first time, initialize $context.
    if (empty($context['sandbox'])) {
      $context['sandbox']['total'] = $this->getTotal();
      $context['sandbox']['current'] = 0;
      if ($context['sandbox']['total'] == 0) {
        $context['finished'] = 1;
        return;
      }
    }

    // Execute the operation.
    $this->process($context['sandbox']['current'], $context['sandbox']['total']);

    // Update finished value 0..1
    $context['finished'] = $context['sandbox']['current'] / $context['sandbox']['total'];
  }

  /**
   * Update the $context upon each iteration of this operation.
   *
   * This function is to be called at the end of each iteration in the operation loop.
   */
  function updateContext() {
    $this->context['results'][$this->token]++;
    $this->context['sandbox']['current']++;
    $current = $context['sandbox']['current'];
    $this->context['message'] = t('Importing @token @current of @total.', array(
      '@token' => $this->token,
      '@current' => $this->context['sandbox']['current'],
      '@total' => $this->context['sandbox']['total']
      ));
  }

  /**
   * Call dpm() if devel module is enabled.
   */
  function dpm() {
    if (module_exists('devel')) {
     $args = func_get_args();
     call_user_func_array('dpm', $args);
    }
  }

  /**
   * Returns the uid for $name or FALSE.
   */
  function findUser($name) {
    $rsc = db_query("SELECT uid FROM {users} u WHERE name = '%s'", array($name));
    if ($user = db_fetch_object($rsc)) {
      return $user->uid;
    }
    return FALSE;
  }

  /**
   * Obtain the drupal uid for a dada user.
   *
   * Use a internal cache as presumibly this function can be called
   * several times in the same batch iteration.
   *
   * If user doesn't exist return 0.
   */
  function getUid($objectid) {
    static $users;
    if (!isset($users[$objectid])) {
      $query = "SELECT uid FROM dada_users WHERE objectid=%d";
      $uid = db_result(db_query($query, $objectid));
      if ($uid === FALSE) {
        $uid = 0;
      }
      $users[$objectid] = $uid;
    }

    return $users[$objectid];
  }

  /**
   * Obtain the tid for a dada category.
   *
   * Use a internal cache as presumibly this function can be called
   * several times in the same batch iteration.
   */
  function getTerm($objectid) {
    static $terms = array();
    if (!isset($terms[$objectid])) {
      $query = "SELECT tid FROM dada_categories WHERE objectid=%d";
      $tid = db_result(db_query($query, $objectid));
      $terms[$objectid] = $tid;
    }

    return $terms[$objectid];
  }

  /**
   * Obtain the nid for a dada article, feature or media.
   *
   * Use a internal cache as it is much used by comments import.
   */
  function getNid($objectid, $class = 'Article') {
    static $nids = array('Article' => array(), 'Feature' => array(), 'Media' => array());
    if (!isset($nids[$class][$objectid])) {
      $table = 'dada_'.strtolower($class);
      if ($class != 'Media') {
        $table .= 's';
      }
      $query = "SELECT nid FROM {$table} WHERE objectid=%d";
      $nid = db_result(db_query($query, $objectid));
      $nids[$class][$objectid] = $nid;
    }
    return $nids[$class][$objectid];
  }

  /**
   * Obtain the cid for a dada comment.
   *
   * Use a internal cache as it is much used by comments import.
   */
  function getCid($objectid) {
    static $cids = array();
    if (!isset($cids[$objectid])) {
      $query = "SELECT cid FROM {dada_comments} WHERE objectid=%d";
      $cid = db_result(db_query($query, $objectid));
      $cids[$objectid] = $cid;
    }
    return $cids[$objectid];
  }
  
  /**
   * Save dada articles or features as nodes.
   */
  function saveNode(&$row) {
    if (($row->heading == "") &&
      ($row->summary == "") &&
      ($row->body == "")
    ) {
      drupal_set_message(t('Empty !type !objectid.', array('!type' => $row->type, '!objectid' => $row->objectid)), 'warning');
      return FALSE;
    }
    $created_datetime = strtotime($row->created_datetime);
    if (!$created_datetime) {
      $created_datetime = strtotime($row->edit_datetime);
    }
    // node path.
    switch ($row->type) {
      case 'Article': 
        $path = 'newswire/';
        break;
      case 'Feature':
        $path = 'feature/';
        break;
      case 'Media':
        $path = 'media/all/';
        break;
    }
    $path .= 'display/'.$row->objectid.'/index.php';
    // Terms.
    // Dada categories.
    $terms = array();
    $query = 'SELECT DISTINCT category_id FROM hash_category WHERE ref_class="%s" AND ref_id=%d AND category_id != 0';
    $rsc = $this->dbQuery($query, $row->type, $row->objectid);
    while ($cat = mysql_fetch_object($rsc)) {
      $terms[] = $this->getTerm($cat->category_id);
    }
    // Dada section.
    /* TODO: section for Otherpress and Media ? */
    $sections = variable_get('dadaimc2drupal_sections_terms', array());
    if (isset($sections[$row->section])) {
      $terms[] = $sections[$row->section];
    }
    // User id based on authorid. TODO: allow for an author textfield.
    $uid = $this->getUid($row->authorid);
    // Import files.
    $files = $this->importFiles($row, $created_datetime, $uid);
    // Body, with inline media.
    $body = $row->body ? "<!--break-->\n\n". $row->body : '';
    $this->inlineMedia($body, $row->embedded_media, $files);
    $body = $row->summary . $body;
    // Input format.
    // Here we assume Full HTML = 2 and Filtered HTML = 1 as in a standard
    // drupal installation.
    $input_format = ($row->mime_type == 'text/html')?2:1;
    // Related urls. TODO: use a link field
    $related = array();
    if ($row->related_url1 || $row->related_url2) {
      $related[] = '<strong>Related</strong>';
      if ($row->related_url1) {
        $related[] = '<a href="'. $row->related_url1 .'">'. $row->related_url1 .'</a>';
      }
      if ($row->related_url2) {
        $related[] = '<a href="'. $row->related_url2 .'">'. $row->related_url2 .'</a>';
      }
      if ($input_format == 2) {
        $related = '<p>'.implode('</p><p>', $related).'</p>';
      }
      else {
        $related = "\n".implode("\n", $related)."\n";
      }
      $body .= $related;
    }
    $old_path = '<a href="'.variable_get('dadaimc_url', '').'/'.$path.'">link to old path</a><br/>'."\n";

    $node = (object)array(
      'type'     => $row->node_type,
      'title'    => str_replace("&quot;", "\"", $row->heading),
      'teaser'   => $old_path.$row->summary,
      'body'     => $old_path.$body,
      'status'   => $row->displayable,
      'created'  => $created_datetime,
      'changed'  => strtotime($row->modified_timestamp),
      'promote'  => $row->feature,
      'comment'  => 1, // (1 = no further comments)
      'format'   => $input_format,
      //'language' => 'en',
      'uid'      => $uid,
      'path'     => $path,
      'files'    => $files,
      'taxonomy' => $terms
    );
    node_save($node);
    if ($node->nid) {
      return $node;
    }
    else {
      form_set_error('', t('Error importing !type with objectid !objectid', array('!type' => $row->type, '!objectid' => $row->objectid)));
      $this->dpm($node);
    }
    // #TODO# anonymous attribution.
    /*
    if (($uid == 0) && ($row->author)) {
      db_query('INSERT INTO {nodextradata} (nid, author) VALUES (%d,"%s")', $node->nid, $row->author);
    }
    */

    return $node;
  }

  /**
   * Import files from media table into drupal files table.
   */
  function importFiles(&$row, $created_datetime, $uid) {
    $files = array();
    $query = "SELECT objectid, filename, mime_class, mime_type, caption FROM media WHERE parentid=%d AND parent_class='%s' ORDER BY sequence_number %s";
    $rsc = $this->dbQuery($query, $row->objectid, $row->type, ($row->embedded_media == 'aftersummary' ? "DESC" : "ASC"));
    while ($media = mysql_fetch_object($rsc)) {
      $basepath = $media->mime_class .'/'. $this->fileSubdir($media->filename);
      $path = $basepath . '/' . $media->filename;
      // For images, attach the larger one, if it exists.
      if (strncmp('image/', $media->mime_type, 6) === 0) {
        $path_large = $basepath . '/large/' . $media->filename;
        if (file_exists($path_large)) {
          $path = $path_large;
        }
      }
      $path = $this->filesPath . $path;
      if (!file_exists($path)) {
        //form_set_error('', t('File !path does not exist. Related media object: !objectid', array('!path' => $path, '!objectid' => $media->objectid)));
        continue;
      }
      $file = (object)array(
        'uid'       => $uid,
        'filename'  => $media->filename,
        'filepath'  => $path,
        'filemime'  => $media->mime_type,
        'filesize'  => filesize($path),
        'status'    => FILE_STATUS_PERMANENT,
        'timestamp' => $created_datetime,
      );
      drupal_write_record('files', $file);

      // Prepare for upload.module
      $file->new = TRUE;
      $file->list = FALSE;
      if ($media->caption != $row->heading) {
        $file->description = substr($media->caption, 0, 255);
      }
      $files[$file->fid] = $file;
      $record = array('objectid' => $media->objectid, 'fid' => $file->fid);
      drupal_write_record('dada_files', $record);
    }

    return $files;
  }

  /**
   * Insert files into body with inline tags.
   */
  function inlineMedia(&$body, $embedded_media_type, $files) {
    if (count($files) == 0) {
      return;
    }
    // Create inline macros for each uploaded file.
    // Here we adapt to the logic in inline.module, based on form_submit
    // see @inline_form_submit()
    // see @inline_nodeapi()
    $all_macros = '';
    foreach ($files as $fid => $file) {
      $macro = '[upload|file='.$file->filename.'|fid='.$fid;
      if (isset($file->description)) {
        $macro .= '|title='.$file->description;
      }
      $macro .= ']';
      $all_macros .= $macro;
    }
    foreach (inline_get_macros($all_macros) as $original => $macro) {
      inline_macro_save($macro);
      $GLOBALS['inline'][$macro->iid] = $macro;
      $files[$macro->params['fid']]->inline = '[inline|iid='.$macro->iid.']';
    }
    // Insert the macros based on the type of media embed for this article.
    switch ($embedded_media_type) {
      case 'oneaftersummary':
        $file = array_shift($files);
        $body = $file->inline . $body;
        foreach ($files as $file) {
          $body .= $file->inline;
        }
        break;
      case 'placeholders':
        $keys = array_keys($files);
        $i = 1;
        foreach ($files as $file) {
          $body = str_replace("#file_$i#", $file->inline, $body);
          $i++;
        }
        break;
      case 'aftersummary':
      default:
        $html = '';
        foreach ($files as $file) {
          $html .= $file->inline;
        }
        $body = ($embedded_media_type == 'aftersummary')?$html.$body:$body.$html;
        break;
    }
    return;
  }

  /**
   * Copied from dadaimc. Used to sortof hash media files into directories 1..13.
   */
  function fileSubdir($filename) {
    // gets a number between 1 and 13 using the first character
    $num = 0;
    for ($x = 0; $x < strlen($filename); $x++) {
      $num += ord($filename[$x]);
    }
    return ($num % 13) + 1;
  }
}
