<?php

require_once 'base.batch.inc';

/**
 * Batch operation. Import dadaIMC comments.
 *
 * Fields not imported:
| modified_timestamp | modified_by | deleted | edit_datetime | language | author | lft | rgt | submitted | displayable | rating | license 
 */
class dadaImportComments extends BaseBatchOperation implements iBatchOperation {
  public $token = 'comments';

  function getTotal() {
    $query = 'SELECT COUNT(objectid) FROM comments WHERE deleted = 0';
    $total = mysql_result($this->dbQuery($query), 0);
    return $total;
  }

  function process($current, $total) {
    $query = "SELECT objectid, root_class, rootid, parent_class, parentid, created_datetime, heading, summary, body, authorid, author, related_url1, related_url2, embedded_media, mime_type FROM comments WHERE deleted = 0 ORDER BY objectid ASC LIMIT $current,".$this->step;
    $rsc = $this->dbQuery($query);
    while ($row = mysql_fetch_object($rsc)) {
      // Root node.
      $nid = $this->getNid($row->rootid, $row->root_class);
      if (!$nid) {
        form_set_error('', t('Skip import of comment !objectid because parent node (!class !id) was not imported.', array('!objectid' => $objectid, '!class' => $row->root_class, '!id' => $row->rootid)));
        $this->context['sandbox']['current']++;
        continue;
      }
      // Parent id.
      if ($row->parent_class == 'Comment') {
        $pid = $this->getCid($row->parentid);
      }
      else {
        $pid = 0;
      }
      $timestamp = strtotime($row->created_datetime);
      $uid = $this->getUid($authorid);
      $files = $this->importFiles($row, $timestamp, $uid);
      // Body, with inline media.
      $old_path = '<a href="'.variable_get('dadaimc_url', '').'/mod/comments/display/'.$row->objectid.'/index.php">link to old path</a><br/>'."\n";
      $body = $row->body ? "<!--break-->\n\n". $row->body : '';
      $this->inlineMedia($body, $row->embedded_media, $files);
      $body = $old_path . $row->summary . $body;

      // Input format.
      // Here we assume Full HTML = 2 and Filtered HTML = 1 as in a standard
      // drupal installation.
      $input_format = ($row->mime_type == 'text/html')?2:1;
// TODO: related urls... probably refactor saveNode and extract common functionality
      $comment = array(
        'nid'     => $nid,
        // dadaimc comment's subject is varchar(255).
        'subject' => substr($row->heading, 0, 64),
        'comment' => $body,
        'format'  => $input_format,
        'pid'     => $pid,
        'uid'     => $uid,
        'name'    => $row->author,
        'files'   => $files,
      );
      // Save the comment.
      $cid = comment_save($comment);
      if (!$cid) {
        form_set_error('', t('Error importing comment with objectid !objectid', array('!objectid' => $row->objectid)));
        $this->dpm($row);
        $this->dpm($comment);
      }
      else {
        // Sadly the comment_save function sets timestamp to time()...
        db_query("UPDATE {comments} SET timestamp=%d WHERE cid=%d", array($timestamp, $cid));
        $record = array('objectid' => $row->objectid, 'cid' => $cid);
        drupal_write_record('dada_comments', $record);
      }
      $this->updateContext();
    }
  }
}
