<?php

require_once 'base.batch.inc';

/**
 * Batch operation. Import dadaIMC features as nodes.
 *
 * Fields not imported:
 *  modified_by | language | author | thumbnail | submitted | rating | license |
 */
class dadaImportFeatures extends BaseBatchOperation implements iBatchOperation {
  public $token = 'features';

  function getTotal() {
    $query = 'SELECT COUNT(objectid) FROM features WHERE deleted=0';
    $total = mysql_result($this->dbQuery($query), 0);
    return $total;
  }

  function process($current, $total) {
    $node_type = variable_get('dadaimc2drupal_node_type_features', '');
    $query = "SELECT objectid, refid, ref_class, created_datetime, edit_datetime, heading, displayable, modified_timestamp, authorid, summary, section, embedded_media, related_url1, related_url2, mime_type FROM features WHERE deleted=0 ORDER BY objectid ASC LIMIT $current, ".$this->step;
    $rsc = $this->dbQuery($query);
    while ($row = mysql_fetch_object($rsc)) {
      // If linked to an article move the newswire summary into the body and
      // set summmary and title to be that of the feature.
      // Known flaw: input format for feature and article may not be the same.
      if ($row->ref_class != '') {
        $nid = $this->getNid($row->refid, $row->ref_class);
        if (!$nid) {
          drupal_set_message(t('Feature !feature not imported as referenced !class !refid was not imported.', array('!feature' => $row->objectid, '!class'=> $row->ref_class, '!refid' => $row->refid)), 'error');
          $this->context['sandbox']['current']++;
          continue;
        }
        $created_datetime = strtotime($row->created_datetime);
        if (!$created_datetime) {
          $created_datetime = strtotime($row->edit_datetime);
        }
        $node = node_load($nid);
        $node->type = $node_type; //Does it work without a drawback?
        $node->title = $row->title;
        $node->teaser = $row->summary;
        $this->inlineMedia($row->summary, $row->embedded_media, $node->files);
        $node->teaser = $row->summary;
        $node->created = $created_datetime;
        $node->status = $row->displayable;
        $node->body = "<!--break-->". str_replace("<!--break-->", "", $node->body);
        node_save($node);
      }
      // Feature not linked to article.
      else {
        $row->feature = 1;
        $row->type = "Feature";
        $row->node_type = $node_type;
        $row->body = "";
        $node = $this->saveNode($row);
      }
      if (is_object($node)) {
        $record = array('objectid' => $row->objectid, 'nid' => $node->nid);
        drupal_write_record('dada_features', $record);
      }
      $this->updateContext();
    }
  }
}
