<?php

require_once 'base.batch.inc';

/**
 * Batch operation.
 */
class dadaImportObjections extends BaseBatchOperation implements iBatchOperation {
  public $token = 'objections';

  function getTotal() {
    $query = 'SELECT COUNT(*) FROM {objections} WHERE type IN ("Article", "Media", "Comment") AND hide=1 AND hide_code!="Submitted as Feature"';
    $total = mysql_result($this->dbQuery($query), 0);
    return $total;
  }

  function process($current, $total) {
    $reasons = $this->getReasons();
    $query = 'SELECT modified_timestamp, refid, type, hide_code, hide_notes, user FROM {objections} WHERE type IN ("Article", "Media", "Comment") AND hide=1 AND hide_code!="Submitted as Feature" ORDER BY modified_timestamp DESC LIMIT '.$current.','.$this->step;
    $rsc = $this->dbQuery($query);
    while ($row = mysql_fetch_object($rsc)) {
      $hidden = FALSE;
      if ($row->type == 'Comment') {
       $table = 'hidden_comment';
        $cid = $this->getCid($row->refid);  
        if ($cid) {
          $comment = _comment_load($cid);
          $hidden = array(
            'nid' => $comment->nid,
            'cid' => $comment->cid,
          );
        }
      }
      else {
        $table = 'hidden_node';
        $nid = $this->getNid($row->refid, $row->type);
        if ($nid) {
          $hidden = array(
            'nid' => $nid,
          );
        }
      }
      // Node/Comment to object does not exist.
      if (!$hidden) {
        $this->context['sandbox']['current']++;
        continue;
      }
      // Node/Comment is already objected. May be duplicate rows in dadaimc.
      $query = "SELECT COUNT(*) FROM {$table} WHERE nid=%d";
      if (isset($hidden[$cid])) {
        $query .= " AND cid=%d";
      }
      if (db_result(db_query($query, array($hidden['nid'], $hidden['cid'])))) {
        $this->context['sandbox']['current']++;
        continue;
      }

      $hidden += array(
        'rid'         => $reasons[$row->hide_code],
        'created'     => strtotime($row->modified_timestamp),
        'publicnote'  => $row->hide_notes,
        'privatenote' => '',
        'uid'         => $this->findUser($row->user)
      );
      drupal_write_record($table, $hidden);
      $this->updateContext();
    }
  }

  /**
   * Return an array mapping dadaimc's objections to drupal hidden.module's reasons.
   *
   * It import the objections as reasons the first time it is invoked.
   */
  function getReasons() {
    $reasons = variable_get('dadaimc2drupal_objections_map', FALSE);
    if (!$reasons) {
      // Some of the objections in dadaimc.
      // Not used: 'Submitted as Feature'
      // Already provided by hidden module: Policy Violation
      $hide_codes = array('Never Submitted', 'Empty', 'Duplicate post', 'Advertising', 'Repost', 'Policy Violation', 'Rated Down', 'Other');
      $reasons = array('Policy Violation' => 1);
      foreach ($hide_codes as $code) {
        $record = array('title' => $code);
        drupal_write_record('hidden_reasons', $record);
        $reasons[$code] = $record['rid'];
      }
      variable_set('dadaimc2drupal_objections_map', $reasons);
    }
    return $reasons;
  }
}
